#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <errno.h>

int main(void) {
    char *str = "012ABC345";
    char *endptr;
    long lval;
    unsigned long ulval;

    printf("atoi() ==============================================\n");
    printf( "%d\n", atoi(str));
    printf("atol() ==============================================\n");
    printf( "%ld\n", atol(str));
    printf("atof() ==============================================\n");
    printf( "%f\n", atof(str));
    printf("strtol() ============================================\n");
    lval = strtol(str, &endptr, 0);
    if ((errno == ERANGE && (lval == LONG_MAX || lval == LONG_MIN))
        || (errno != 0 && lval == 0)) {
        perror("strtol");
    }
    if (endptr == str) {
        fprintf(stderr, "strtol:l܂B\n");
    }
    if (*endptr != '\0') {
        printf("ϊ܂B: %s\n", endptr);
    }
    printf("%li\n", lval);
    printf("strtoul() ===========================================\n");
    ulval = strtoul(str, NULL, 10);  /* uendptrvQƂȂꍇNULL */
    if ((errno == ERANGE && ulval == ULONG_MAX)
        || (errno != 0 && ulval == 0)) {
        perror("strtoul");
    }
    printf("%lu\n", ulval);
    printf("strtod() ============================================\n");
    printf( "%f\n", strtod(str, NULL));

    return 0;
}
